// SplitterWindowControlPpg.cpp : Implementation of the CSplitterWindowControlPropPage property page class.

#include "stdafx.h"
#include "SplitterWindowControl.h"
#include "SplitterWindowControlCtl.h"
#include "SplitterWindowControlPpg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CSplitterWindowControlPropPage, COlePropertyPage)


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CSplitterWindowControlPropPage, COlePropertyPage)
	//{{AFX_MSG_MAP(CSplitterWindowControlPropPage)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CSplitterWindowControlPropPage, "SPLITTER.SplitterCrtlPropPage.1",
	0xef42cc67, 0x68b4, 0x11d2, 0xb8, 0x17, 0xdd, 0xf1, 0x21, 0x7c, 0x87, 0x2f)


/////////////////////////////////////////////////////////////////////////////
// CSplitterWindowControlPropPage::CSplitterWindowControlPropPageFactory::UpdateRegistry -
// Adds or removes system registry entries for CSplitterWindowControlPropPage

BOOL CSplitterWindowControlPropPage::CSplitterWindowControlPropPageFactory::UpdateRegistry(BOOL bRegister)
{
	if (bRegister)
		return AfxOleRegisterPropertyPageClass(AfxGetInstanceHandle(),
			m_clsid, IDS_SPLITTERWINDOWCONTROL_PPG);
	else
		return AfxOleUnregisterClass(m_clsid, NULL);
}


/////////////////////////////////////////////////////////////////////////////
// CSplitterWindowControlPropPage::CSplitterWindowControlPropPage - Constructor

CSplitterWindowControlPropPage::CSplitterWindowControlPropPage() :
	COlePropertyPage(IDD, IDS_SPLITTERWINDOWCONTROL_PPG_CAPTION)
{
	//{{AFX_DATA_INIT(CSplitterWindowControlPropPage)
	m_strFirstControlName = _T("");
	m_strSecondControlName = _T("");
	m_bVertical = FALSE;
	//}}AFX_DATA_INIT
}


/////////////////////////////////////////////////////////////////////////////
// CSplitterWindowControlPropPage::DoDataExchange - Moves data between page and properties

void CSplitterWindowControlPropPage::DoDataExchange(CDataExchange* pDX)
{
	//{{AFX_DATA_MAP(CSplitterWindowControlPropPage)
	DDX_Control(pDX, IDC_COMBO_SECOND_CONTROL_NAME, m_cbxSecondControlName);
	DDX_Control(pDX, IDC_COMBO_FIRST_CONTROL_NAME, m_cbxFirstControlName);
	DDP_CBString(pDX, IDC_COMBO_FIRST_CONTROL_NAME, m_strFirstControlName, _T("strFirstControlName") );
	DDX_CBString(pDX, IDC_COMBO_FIRST_CONTROL_NAME, m_strFirstControlName);
	DDP_CBString(pDX, IDC_COMBO_SECOND_CONTROL_NAME, m_strSecondControlName, _T("strSecondControlName") );
	DDX_CBString(pDX, IDC_COMBO_SECOND_CONTROL_NAME, m_strSecondControlName);
	DDP_Check(pDX, IDC_CHECK_VERTICAL, m_bVertical, _T("bVertical") );
	DDX_Check(pDX, IDC_CHECK_VERTICAL, m_bVertical);
	//}}AFX_DATA_MAP
	DDP_PostProcessing(pDX);
}


/////////////////////////////////////////////////////////////////////////////
// CSplitterWindowControlPropPage message handlers

BOOL CSplitterWindowControlPropPage::OnInitDialog() 
{
	COlePropertyPage::OnInitDialog();
	
	// TODO: Add extra initialization here
	long pointer=0;
	GetPropText(_T("_pointer"),&pointer);

	CCmdTarget* pCmdTarget=(CCmdTarget*)pointer;
	if(pCmdTarget->IsKindOf(RUNTIME_CLASS(CSplitterWindowControlCtrl)))
	{
		CSplitterWindowControlCtrl* pControl=(CSplitterWindowControlCtrl*)pCmdTarget;
		CControlInfoArray arrayControls;
		pControl->GetOtherControlsOnTheContainer(arrayControls);
		for(int i=0; i<arrayControls.GetSize(); i++)
		{
			m_cbxFirstControlName.AddString(arrayControls[i].m_strName);
			m_cbxSecondControlName.AddString(arrayControls[i].m_strName);
		}
	}
	
	return FALSE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
